Strict
Framework brl.blitz
Import brl.d3d9max2d
Import brl.timer
Import brl.random
Import brl.filesystem
Import brl.ramstream
Import brl.pngloader

Const BOXV = 12
Global timer:TTimer = CreateTimer(50)

SeedRnd MilliSecs()
Incbin "m.png"
Incbin "x.png"
Incbin "a.png"

Const GW = 800, GH = 600, GHS = (GH-160)/6
AppTitle = "Gravitron Mini"
Graphics GW, GH
SetMaskColor 255, 0, 255
Global obest=0
Local f:TStream = ReadFile("best.dat")
If f Then obest = ReadInt(f); CloseFile f
AutoMidHandle 1
TBox.loadimg()
Local i=0
While game(i);i = $FF;Wend
ShowMouse
End

Function save(x)
	If x > obest Then
		Local f:TStream = WriteFile("best.dat")
		WriteInt f, x
		CloseFile f
		obest = x
	EndIf
EndFunction

Function err()
	RuntimeError "error"
EndFunction

Function pad$(x)
	If x < 10 Then Return "0"+x Else Return x
EndFunction

Function ftime$(x)
	Return pad(x/60000)+":"+pad((x/1000) Mod 60)+":"+pad((x Mod 1000)/10)
EndFunction

Type TPlayer
	Field x, y, ydir = 16
	Global img:TImage, w = 30, h = 60
	
	Function Load()
		img = LoadImage("incbin::m.png")
		If Not img Then err
		w = ImageWidth(img)
		h = ImageHeight(img)
	EndFunction
	
	Method update()
		If img Then
			If ydir < 0 Then SetScale 1, -1
			DrawImage img, x, y
			SetScale 1, 1
		Else
			SetColor 0, 255, 0
			DrawRect x - w/2, y - h/2, w, h 
		EndIf
		
		y :+ ydir
		If y+h/2 > GH-60 Then
			ydir = -ydir
			y = GH-60-h/2
		ElseIf y-h/2 < 60 Then
			ydir = -ydir
			y = 60+h/2
		EndIf
			
		If x > GW Then
			x :- GW
		ElseIf x < 0 Then
			x :+ GW
		EndIf
	EndMethod
EndType

Function r01()
	Return Rand(0, 1999)/1000
EndFunction

Function game(started=0)
	Const SG$="Start Game", THRESH = 50

	Local starttime = MilliSecs()
	Local time, player:TPlayer = New TPlayer
	Local SG_W = TextWidth(SG), SG_H = TextHeight(SG)
	Local actime = 4000, ltime = MilliSecs()-actime
	Local best$=ftime(obest)
	player.x = GW/2
	player.y = GH/2
	
	TBox.all.clear
	TPlayer.Load
	
	Repeat
		Cls
		
		SetColor 255, 255, 255
		DrawRect 0, 60, GW, 1
		DrawRect 0, GH-60, GW, 1

		SetColor 255, 255, 255
		SetScale 1.6, 1.6		
		DrawText "TIME: ", 10, 10
		DrawText "BEST TIME: "+best, GW-300, 10
		
		If started > THRESH Then
			time = MilliSecs() - starttime

			DrawText ftime(time), 90, 10

			SetScale 1, 1

			If TBox.updateall(player) Then
				time = MilliSecs() - starttime

				For Local i = 1 To 12
					SetColor 255, 255, 255
					DrawImage TPlayer.img, player.x, player.y
					Delay 70
					Flip 0
					SetColor 0,0,0
					DrawImage TPlayer.img, player.x, player.y
					Delay 70
					Flip 0
				Next
			
				Exit
			EndIf

			player.update
			
			Local xp = MouseX()-GW/2
			If xp < -BOXV+1 Then xp = -BOXV+1 ElseIf xp > BOXV-1 Then xp = BOXV-1
			player.x :+ xp
			
			If time > 1500 And MilliSecs()-ltime > actime Then
				TBox.newform
				ltime = MilliSecs()
				If actime > 2000 Then actime :- 50
			EndIf

			MoveMouse GW/2, GH/2
		Else
			SetScale 1, 1
			Local sw = started*120/THRESH
			If started Then SetColor 0, 255, 0;DrawRect GW/2-60, GH/2-25, sw, 50

			SetColor 255, 255, 255
			DrawRect GW/2-60+sw, GH/2-25, 120-sw, 50
			SetColor 0,0,0
			DrawText SG, (GW-SG_W)/2, (GH-SG_H)/2
			
			If mousein(GW/2-60, GH/2-25, 120, 50) Then started :+ 1 Else started = 0
			
			If started > THRESH Then starttime = MilliSecs();HideMouse
		EndIf

		WaitTimer timer
		Flip 0
		If AppTerminate() Or KeyHit(KEY_ESCAPE) Then save(time);Return 0
	Forever
	
	save(time)
	
	Return 1
EndFunction

Function mousein(x,y,w,h)
	Local mx = MouseX(), my = MouseY()
	Return mx > x And my > y And mx < x+w And my < y+h
EndFunction

Type TBox
	Global all:TList = New TList
	Global img:TImage, w, h, r2, arr:TImage
	Field x, y, xdir, alive = False
	
	Function newbox:TBox(p:TBox, x, y, xdir = 0)
		Local b:TBox = New TBox
		If p Then
			b.x = p.x + x*p.xdir
			b.y = p.y + y
			b.xdir = p.xdir
		Else
			b.x = x
			b.y = y
			b.xdir = xdir
		EndIf
		all.addlast b
			
		Return b
	EndFunction
	
	
	Function newform()
		Local p:TBox, x, xdir, ax
		Local n = Rand(0,319)/64
		
		xdir = r01()
		x = xdir*(GW+w*50)-w*25
		ax = (1-xdir)*(GW+w*50)-w*25
		xdir = -(xdir*2-1)
		
		Select n
		Case 0
			p = newbox(Null, x, 2*GHS+60, xdir)
			newbox p, -30, GHS
			newbox p, 30, GHS
			newbox p, -30, GHS*2
			newbox p, 30, GHS*2
			newbox p, 0, GHS*3
		Case 1
			p = newbox(Null, x, GHS+60, xdir)
			newbox p, -30, GHS
			newbox p, -120, GHS*4
			newbox p, -150, GHS*5
		Case 2
			p = newbox(Null, x, GHS+60, xdir)
			newbox p, 0, GHS
			newbox p, 0, GHS*2
			p = newbox(p, -300, GHS*3, xdir)
			newbox p, 0, GHS
			newbox p, 0, GHS*2
			p = newbox(p, -300, -GHS*3, xdir)
			newbox p, 0, GHS
			newbox p, 0, GHS*2
		Case 3
			p = newbox(Null, x, GHS*3+60, xdir)
			newbox p, -200, 0
			newbox p, -400, 0
			newbox p, -600, 0
			newbox p, -800, 0
		Case 4
			p = newbox(Null, x, GHS*2+60, xdir)
			newbox p, -300, 0
			newbox p, -600, 0
			p = newbox(Null, ax, GHS*4+60, -xdir)
			newbox p, -300, 0
			newbox p, -600, 0
		EndSelect
	EndFunction
	
	Function loadimg()
		img = LoadImage("incbin::x.png")
		arr = LoadImage("incbin::a.png")
		If Not(img And arr) Then err
		w = ImageWidth(img)
		h = ImageHeight(img)
		r2 = w*w/4
	EndFunction
	
	Function updateall(pl:TPlayer)
		Local dead = 0
		For Local b:TBox = EachIn all
			If b.update() Then
				If ImagesCollide(TPlayer.img, pl.x, pl.y, 0, img, b.x, b.y, 0) Then dead = 1
			Else
				all.remove b
			EndIf
		Next
		Return dead
	EndFunction
	
	Method update()
		DrawImage img, x, y
		
		If alive Then
			If x < -w/2 Or x > GW+w/2 Then Return 0
		Else
			If x > -w*11 And x < GW+w*11 Then
				Local ax
				If x < 0 Then ax = 15 Else ax = GW-15;SetScale -1, 1
				DrawImage arr, ax, y
				SetScale 1,1
			EndIf
			If x >= -w/2 And x <= GW+w/2 Then alive = True
		EndIf
				
		x :+ xdir*BOXV
		
		Return 1
	EndMethod
EndType